<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJobInterfaceResult_v3 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJobInterfaceResult_v3 extends AbstractStructArrayBase
{
    /**
     * The JobInterfaceResult_v3
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\JobInterfaceResult_v3[]
     */
    public $JobInterfaceResult_v3;
    /**
     * Constructor method for ArrayOfJobInterfaceResult_v3
     * @uses ArrayOfJobInterfaceResult_v3::setJobInterfaceResult_v3()
     * @param \StructType\JobInterfaceResult_v3[] $jobInterfaceResult_v3
     */
    public function __construct(array $jobInterfaceResult_v3 = array())
    {
        $this
            ->setJobInterfaceResult_v3($jobInterfaceResult_v3);
    }
    /**
     * Get JobInterfaceResult_v3 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\JobInterfaceResult_v3[]|null
     */
    public function getJobInterfaceResult_v3()
    {
        return isset($this->JobInterfaceResult_v3) ? $this->JobInterfaceResult_v3 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setJobInterfaceResult_v3 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setJobInterfaceResult_v3 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateJobInterfaceResult_v3ForArrayConstraintsFromSetJobInterfaceResult_v3(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item) {
            // validation for constraint: itemType
            if (!$arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item instanceof \StructType\JobInterfaceResult_v3) {
                $invalidValues[] = is_object($arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item) ? get_class($arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item) : sprintf('%s(%s)', gettype($arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item), var_export($arrayOfJobInterfaceResult_v3JobInterfaceResult_v3Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The JobInterfaceResult_v3 property can only contain items of type \StructType\JobInterfaceResult_v3, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set JobInterfaceResult_v3 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\JobInterfaceResult_v3[] $jobInterfaceResult_v3
     * @return \ArrayType\ArrayOfJobInterfaceResult_v3
     */
    public function setJobInterfaceResult_v3(array $jobInterfaceResult_v3 = array())
    {
        // validation for constraint: array
        if ('' !== ($jobInterfaceResult_v3ArrayErrorMessage = self::validateJobInterfaceResult_v3ForArrayConstraintsFromSetJobInterfaceResult_v3($jobInterfaceResult_v3))) {
            throw new \InvalidArgumentException($jobInterfaceResult_v3ArrayErrorMessage, __LINE__);
        }
        if (is_null($jobInterfaceResult_v3) || (is_array($jobInterfaceResult_v3) && empty($jobInterfaceResult_v3))) {
            unset($this->JobInterfaceResult_v3);
        } else {
            $this->JobInterfaceResult_v3 = $jobInterfaceResult_v3;
        }
        return $this;
    }
    /**
     * Add item to JobInterfaceResult_v3 value
     * @throws \InvalidArgumentException
     * @param \StructType\JobInterfaceResult_v3 $item
     * @return \ArrayType\ArrayOfJobInterfaceResult_v3
     */
    public function addToJobInterfaceResult_v3(\StructType\JobInterfaceResult_v3 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JobInterfaceResult_v3) {
            throw new \InvalidArgumentException(sprintf('The JobInterfaceResult_v3 property can only contain items of type \StructType\JobInterfaceResult_v3, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->JobInterfaceResult_v3[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JobInterfaceResult_v3|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JobInterfaceResult_v3|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JobInterfaceResult_v3|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JobInterfaceResult_v3|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JobInterfaceResult_v3|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string JobInterfaceResult_v3
     */
    public function getAttributeName()
    {
        return 'JobInterfaceResult_v3';
    }
}
